<?

require_once 'includes/application_top.php';

/**
 * File:  handler.php
 * Port of _handler.py, written by Alan Runyan (Enfold Systems)
 * Author:  Robocommerce, LLC (Zvi Boshernitzan and Brian Rosenthal)
 * Derived work of _handler.py, which belongs to Alan Runyan (alan@enfoldsystems.com)
 */




/**
 * Some database query templates
 */
define('PUBLISHED_CONTENT_QUERY', "SELECT * FROM cmf_meta 
                           WHERE portal_type = '%s' 
                           AND review_state = 'published' 
                           ORDER BY created DESC");
/*define('QUERY_SIBLINGS', 
    "SELECT cmf_meta.portal_type
	, cmf_meta.path
, cmf_meta.title
, cmf_meta.description
, r1.name AS subj
, r2.name AS pred
, CASE WHEN t.objtype = 1 THEN r3.name ELSE l.value END AS obj
    FROM triples t, resources r1, resources r2,
    namespaces n1, namespaces n2, cmf_meta
    LEFT JOIN literals l ON t.object = l.hash
    LEFT JOIN resources r3 ON t.object = r3.hash
    LEFT JOIN namespaces n3 ON r3.ns = n3.hash
    WHERE t.subject = r1.hash AND
    r1.ns = n1.hash AND
    t.predicate = r2.hash AND
    r2.ns = n2.hash AND
    cmf_meta.uid = r1.name AND
	CASE WHEN t.objtype = 1 THEN r3.name ELSE l.value END = '{parent_uid}'
	and cmf_meta.review_state='published'
	");
*/

define ('QUERY_SIBLINGS',"SELECT cmf_meta.portal_type
	, cmf_meta.path
, cmf_meta.title
, cmf_meta.description
, r1.name AS subj
, r2.name AS pred
, CASE WHEN t.objtype = 1 THEN r3.name ELSE l.value END AS obj
, cmf_meta.relative_path

    FROM 
cmf_meta inner join resources r1 on cmf_meta.uid = r1.name
inner join namespaces n1 on n1.hash = r1.ns
inner join triples t on t.subject = r1.hash
inner join resources r2 on r2.hash=t.predicate
inner join namespaces n2 on r2.ns = n2.hash
    LEFT JOIN literals l ON t.object = l.hash
    LEFT JOIN resources r3 ON t.object = r3.hash
    LEFT JOIN namespaces n3 ON r3.ns = n3.hash
    WHERE 
	CASE WHEN t.objtype = 1 THEN r3.name ELSE l.value END = '{parent_uid}'
	and cmf_meta.review_state='published'");
	
/**
 * URL's are re-written so that:
 * /company/bios/alan becomes handler.php?file=/company/bios/alan&rewritten=true
 */
$file = $_REQUEST['file'];

// the file passed in is also the path
$path = $file;

// name is the last element
$name = array_pop(split('/', $path));

// location of content
$content_base = PREFIX . DIRECTORY_SEPARATOR . CONTENT_DIR;

// location of xml-properties for content
$xml_path = realpath($content_base . '/' . $path);

// if the path is to a directory, try to find index.html
if (is_dir($xml_path)) {

	$index = realpath($xml_path . '/' . 'index_html.data');

	if (file_exists($index)) {
		$xml_path = $index;

	}
	else
	{

		$index = realpath($xml_path . '/' . 'index.html.data');

		if (file_exists($index)) {
			$xml_path = $index;
		}	
		else {
			// if index.html does not exist, use .../.eed/data
			$viewing_folder = true;
			$xml_path = realpath($xml_path . '/.eed/data');
		}
	}
}

// content_url does not include the content base or ".eed/..."
$content_url = str_replace($content_base, '', preg_replace('/\/\.entransit.*$/', '', $xml_path));

// get the events for the site, and the news
$events = db::assocs(sprintf(PUBLISHED_CONTENT_QUERY, 'Event'));
$news = db::assocs(sprintf(PUBLISHED_CONTENT_QUERY, 'News Item'));

// namespace to evaluate the PHP script
$vars = array(
			"menu" => _menu($req, $hlight=$name)
			, "title" => "Enfold Systems"
			, "events" => $events
			, "news" => $news
			, "siblings" => array()
			, "content_url" => $content_url);

// decode the xml
if(file_exists($xml_path.".data"))
{
	$data = xmlrpc_decode(join('', @file($xml_path.".data")));
}
else
{
	if (file_exists($xml_path))
	{
		$data = xmlrpc_decode(join('', @file($xml_path)));
	}
	else
	{
		
		$data = get404Data();
	}
}
// recover the body
/*if($data['review_state']!='published')
{
	$data=get404Data();
}*/
$data['body'] = coalesce($data['body'], $data['description']);

// add the data variables to the namespace
$vars = rba::_($vars, $data);

if (!empty($data['uid'])) {
	// set the siblings
	if (!empty($viewing_folder)) {
		$vars['siblings'] = children($data['uid']);
	}
	else {
		$vars['siblings'] = siblings($data['uid']);
	}
}



// splice into the main template
$main_tmpl = tpl_path(MAIN_TMPL);
// include using the namespace "vars"
include_with_vars($main_tmpl, $vars);

exit();

// ------------------------------------------------------------------------------
// --------------------------- HELPER FUNCTIONS ---------------------------------
// ------------------------------------------------------------------------------

function get404Data()
{
		header("HTTP/1.0 404 Not Found");
		$data=array("body"=>"File Not Found", "review_state"=>"published");
		return $data;
}



/**
 * returns the actual path to the file... checks template directory and main directory
 */
function tpl_path($path, $tmpl_dir = TMPL_DIR) {
	return rb::resolve_file_path($path, $tmpl_dir);
}
/**
 * returns menu as string
 */
function _menu($req, $hlight) {
	static $menu_items = array(
                array("about", "Company", "/About")
                , array("products", "Products", "/Products")
                , array("training", "Training", "/Training")
                , array("support", "Support", "/Support")
                , array("contact", "Contact", "/Contact")
                );

    $menu_tmpl = tpl_path(MENU_TMPL);
	return eval_with_vars($menu_tmpl, compact('hlight', 'menu_items'));
}
/**
 * get parent node uid
 */
function parent_uid($uid) {
	$QUERY_RELATIONSHIP =
	    "
SELECT r1.name AS subj, r2.name AS pred,
    CASE WHEN t.objtype = 1
    THEN r3.name
    ELSE l.value
    END AS obj
    FROM cmf_meta inner join resources r1 on cmf_meta.uid = r1.name
inner join namespaces n1 on n1.hash = r1.ns
inner join triples t on t.subject = r1.hash
inner join resources r2 on r2.hash=t.predicate
inner join namespaces n2 on r2.ns = n2.hash
    LEFT JOIN literals l ON t.object = l.hash
    LEFT JOIN resources r3 ON t.object = r3.hash
    LEFT JOIN namespaces n3 ON r3.ns = n3.hash
    WHERE t.subject = r1.hash AND
    r1.ns = n1.hash AND
    t.predicate = r2.hash AND
    r2.ns = n2.hash AND
    cmf_meta.uid = r1.name AND
    n2.value = '{ns}' AND
    r2.name = '{relation}'";
	$AT_REL_NS = 'http://archetypes.org/references/relation/';

	$QUERY_FORWARD_RELATIONSHIP = $QUERY_RELATIONSHIP . " AND r1.name = '{uid}'";

    $res = db::objects(fmt::tpl($QUERY_FORWARD_RELATIONSHIP, array('ns' => $AT_REL_NS
                                                            , 'relation' => 'contained_into'
                                                            , 'uid' => $uid)));
    if (empty($res)) {
        return null;
    }
    assert('count($res) == 1');
    $res = $res[0];
    return $res->obj;
}

/**
 * get the siblings of a node
 */
function siblings($uid) {
    $parent_uid = parent_uid($uid);
    if (empty($parent_uid)) {
        return array();
    }
	$sibs=db::assocs(fmt::tpl(QUERY_SIBLINGS, compact('parent_uid', 'uid')));
	return $sibs;
}
/**
 * get the children of a node
 */
function children($uid) {
    $parent_uid = $uid;
    return db::assocs(fmt::tpl(QUERY_SIBLINGS, compact('uid', 'parent_uid')));
}

/**
 * run file as php
 */
function include_with_vars($fn, $vars) {
	unset($vars['fn']);
	extract($vars);
	include($fn);
}

/**
 * run as php and return as string
 */
function eval_with_vars($fn, $vars) {
        ob_start();
		include_with_vars($fn, $vars);
        $ret_str = ob_get_contents();
        ob_end_clean();
        return $ret_str;

}



?>
